---
title: Programming in C
subtitle: Typedef and Structs - Composite Data Types
layout: layouts/presentation.njk
---

<section>
  <h2>Purpose of Structs</h2>
  <section>
  <h3>Which Problems Does a <code>struct</code> Solve?</h3>
  <ul>
    <li>Return multiple values from a function</li>
  </ul>
  </section>
  <section>
    <div class="container">
      <div class="column">
$$
x_G = \frac{1}{3} \cdot (x_A + x_B + x_C)
$$
$$
y_G = \frac{1}{3} \cdot (y_A + y_B + y_C)
$$
      </div>
      <div class="column">
        <img src="https://upload.wikimedia.org/wikipedia/commons/a/a3/Centroid_of_a_Triangle.png"
             alt="[centroid of a triangle]">
      </div>
    </div>
  </section>

  <section>
  <p>Example: Calculate the centroid of a triangle.</p>
{% highlight "python" %}
def centroid(x_A, y_A, x_B, y_B, x_C, y_C):
    x_G = 1 / 3 * (x_A + x_B + x_C)
    y_G = 1 / 3 * (y_A + y_B + y_C)
    return x_G, y_G
{% endhighlight %}
<p class="fragment">Without structs, returning more than one value is not possible in C.</p>
  </section>

  <section>
    <h3>Store a Record of Data</h3>
    <p><code>struct</code> is just another word for "record"</p>
    <p class="fragment">A data table can be stored as an array of structs.</p>
    <table class="fragment">
      <tr>
        <th colspan="3" style="text-align: center;">Shopping List</th>
      </tr>
      <tr><td>Apples</td><td>2</td><td>kg</td></tr>
      <tr><td>Lemonade</td><td>4</td><td>l</td></tr>
      <tr><td>Bread</td><td>1</td><td>kg</td></tr>
    </table>
  </section>
</section>

<section>
  <h2>Definition</h2>
  <ul>
    <li>A record (struct) is a basic data structure
      <ul>
        <li>In database / spreadsheet software, a record is usually called a row</li>
      </ul>
    </li>
    <li>Physically grouped list of variables under one name</li>
    <li>Can store mixed-data-type records</li>
    <li>Block of contiguous memory</li>
    {#
    <li>In C++, a <code>struct</code> is identical to a <code>class</code> but has different default visibility
    </li>
    #}
    <li><a href="https://en.wikipedia.org/wiki/Struct_(C_programming_language)">Struct (C programming language)</a></li>
  </ul>
</section>

<section>
  <h2>Declaring and Defining Structs</h2>
  <section>
    <h3>Declaration</h3>
{% highlight "c" %}
struct struct_name {
   type member1;
   type member2;
   /* declare as many members as desired */
};
{% endhighlight %}
  </section>
  <section>
    {# Factor out as real c code file with highlighting the struct declaration. Make runnable! #}
    <h3>Example: Declaration and Definition of a Date</h3>
{% highlight "c" %}
struct date {
   int year;
   int month;
   int day;
};
struct date d = { 2021, 12, 10 };
{% endhighlight %}
<div class="fragment" style="margin-top: 1em;">
The members can also be named explicitly:
{% highlight "c" %}
struct date {
   int year;
   int month;
   int day;
};
struct date d = { .year=2021, .month=12, .day=10 };
{% endhighlight %}
  {% include_code "source/c/structs/date.c" %}
</div>
  </section>
  <section>
    <h3>Typedef</h3>
    <ul>
      <li>Used to create an additional name (alias) for another data type</li>
      <li>Particularly useful in combination with structs</li>
    </ul>
{% highlight "c" %}
typedef type_definition new_identifier;
{% endhighlight %}
  </section>
  <section>
    {# Factor out as real c code file with highlighting the struct declaration. Make runnable! #}
    <h3>Example: Declaration of Point in a 2 Dimensional Space</h3>
{% highlight "c" %}
struct point {
   float x;
   float y;
};
struct point p = {1.5, 3.0};
{% endhighlight %}
<div class="fragment" style="margin-top: 1em;">
Using <code>typedef</code> improves the readability.
{% highlight "c" %}
typedef struct point {
   float x;
   float y;
} Point;
Point p = {1.5, 3.0};
{% endhighlight %}
</div>
  </section>
</section>

<section>
  <h2>Common Operations</h2>
  <section>
    <h3>Assignment</h3>
{% include_code "source/c/structs/assignment.c" %}
{% highlight "c 9" %}
{% include "source/c/structs/assignment.c" %}
{% endhighlight %}
  </section>

  <section>
    <h3>Passing Structs to Functions</h3>
{% include_code "source/c/structs/parameter.c" %}
{% highlight "c 7,14" %}
{% include "source/c/structs/parameter.c" %}
{% endhighlight %}
  </section>

  <section>
    <h3>Returning Structs from Functions</h3>
{% include_code "source/c/structs/return.c" %}
{% highlight "c 11,16" %}
{% include "source/c/structs/return.c" %}
{% endhighlight %}
  </section>

</section>

<section>
  <section>
  <h2>Exercise</h2>
  <ol>
    <li>Create a <code>typedef struct Date</code> that holds
      <code>int year</code>,
      <code>int month</code> and <code>int day</code>.</li>
    <li>Define a function <code>print_date(Date d)</code> that uses
      <code>printf</code> to print a given date to standard output. The date
      must be printed in
      <a href="https://en.wikipedia.org/wiki/ISO_8601">ISO 8601</a>
      format (YYYY-MM-DD), followed by a newline.</li>
    <li>Define today's <code>Date</code> in <code>main</code> and call
      <code>print_date</code> to print today's date.</li>
  </ol>
  </section>

  <section>
    <h2>Solution</h2>
{% include_code "source/c/structs/print_date.c" %}
{% highlight "c" %}
{% include "source/c/structs/print_date.c" %}
{% endhighlight %}
  </section>
</section>

{% include 'slides/closing.njk' %}
